package com.faa.dom.tutorial;

// This GUI is the only part of the program generated using an IDE.
// therefore is the only one without copious comments on every method.
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


import java.util. Vector;
import java.util. Enumeration;
import java.net.  URL;
import java.io.   File;

import com.faa.patterns.Observer.Observer;
import com.faa.patterns.Observer.Observable;

public class DOMCrawlerFrame extends JFrame implements Observer {
  JPanel contentPane;
  JMenuBar menuBar1 = new JMenuBar();
  JMenu menuFile = new JMenu();
  JMenuItem menuFileExit = new JMenuItem();
  JMenu menuHelp = new JMenu();
  JMenuItem menuHelpAbout = new JMenuItem();
  JLabel statusBar_ST = new JLabel();
  JList leftToVisit_JL = new JList();
  JLabel ToVisit_JL = new JLabel();
  JList alreadyVisited_JL = new JList();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JTextField totalImages_JT = new JTextField();
  JPanel jPanel1 = new JPanel();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JLabel jLabel5 = new JLabel();
  JLabel jLabel6 = new JLabel();
  JTextField url_JT = new JTextField();
  JTextField dir_JT = new JTextField();
  JTextField depth_JT = new JTextField();
  JToggleButton Start_Bt = new JToggleButton();
  JLabel jLabel7 = new JLabel();
  JTextField keyword_JT = new JTextField();

  //Construct the frame
  public DOMCrawlerFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(null);
    this.setResizable(false);
    this.setSize(new Dimension(392, 365));
    this.setTitle("DOMCrawler (Tutorial Code for Visitors in DOM)");
    statusBar_ST.setText(" ");
    statusBar_ST.setBounds(new Rectangle(1, 305, 393, 14));
    menuFile.setText("File");
    menuFileExit.setText("Exit");
    menuFileExit.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        fileExit_actionPerformed(e);
      }
    });
    menuHelp.setText("Help");
    menuHelpAbout.setText("About");
    menuHelpAbout.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        helpAbout_actionPerformed(e);
      }
    });
    leftToVisit_JL.setBorder(BorderFactory.createLoweredBevelBorder());
    leftToVisit_JL.setBounds(new Rectangle(10, 29, 175, 114));
    ToVisit_JL.setText("XML Files left to visit:");
    ToVisit_JL.setBounds(new Rectangle(13, 9, 135, 17));
    alreadyVisited_JL.setBorder(BorderFactory.createLoweredBevelBorder());
    alreadyVisited_JL.setBounds(new Rectangle(202, 29, 177, 85));
    jLabel1.setText("XML Files already visited:");
    jLabel1.setBounds(new Rectangle(203, 10, 159, 17));
    jLabel2.setText("Total Images Found:");
    jLabel2.setBounds(new Rectangle(202, 125, 117, 17));
    totalImages_JT.setEditable(false);
    totalImages_JT.setText("0");
    totalImages_JT.setBounds(new Rectangle(336, 120, 41, 21));
    jPanel1.setBackground(new Color(200, 200, 200));
    jPanel1.setBounds(new Rectangle(12, 157, 364, 133));
    jPanel1.setLayout(null);
    jLabel3.setText("Parameters");
    jLabel3.setBounds(new Rectangle(9, 1, 104, 17));
    jLabel4.setText("Starting URL:");
    jLabel4.setBounds(new Rectangle(39, 23, 75, 17));
    jLabel5.setText("Target Directory:");
    jLabel5.setBounds(new Rectangle(15, 47, 99, 17));
    jLabel6.setText("Search Depth:");
    jLabel6.setBounds(new Rectangle(33, 105, 80, 17));
    url_JT.setText("http://www.thefaactory.com/xmldevguide/DOMCrawler/index.xml");
    url_JT.setBounds(new Rectangle(125, 21, 182, 19));
    dir_JT.setToolTipText("");
    dir_JT.setText("c:\\temp\\");
    dir_JT.setBounds(new Rectangle(125, 46, 182, 19));
    depth_JT.setToolTipText("");
    depth_JT.setText("3");
    depth_JT.setBounds(new Rectangle(124, 105, 76, 19));
    Start_Bt.setText("Start");
    Start_Bt.setBounds(new Rectangle(238, 103, 119, 27));
    Start_Bt.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        Start_Bt_actionPerformed(e);
      }
    });
    jLabel7.setToolTipText("Only one please");
    jLabel7.setText("Keyword:");
    jLabel7.setBounds(new Rectangle(53, 78, 55, 17));
    keyword_JT.setToolTipText("");
    keyword_JT.setText("Burton");
    keyword_JT.setBounds(new Rectangle(125, 75, 182, 19));
    menuFile.add(menuFileExit);
    menuHelp.add(menuHelpAbout);
    menuBar1.add(menuFile);
    menuBar1.add(menuHelp);
    this.setJMenuBar(menuBar1);
    contentPane.add(leftToVisit_JL, null);
    contentPane.add(ToVisit_JL, null);
    contentPane.add(alreadyVisited_JL, null);
    contentPane.add(jLabel1, null);
    contentPane.add(jLabel2, null);
    contentPane.add(totalImages_JT, null);
    contentPane.add(jPanel1, null);
    jPanel1.add(jLabel3, null);
    jPanel1.add(jLabel4, null);
    jPanel1.add(jLabel5, null);
    jPanel1.add(url_JT, null);
    jPanel1.add(dir_JT, null);
    jPanel1.add(Start_Bt, null);
    jPanel1.add(jLabel6, null);
    jPanel1.add(depth_JT, null);
    jPanel1.add(jLabel7, null);
    jPanel1.add(keyword_JT, null);
    contentPane.add(statusBar_ST, null);
  }

  //File | Exit action performed
  public void fileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  //Help | About action performed
  public void helpAbout_actionPerformed(ActionEvent e) {
    DOMCrawlerFrame_AboutBox dlg = new DOMCrawlerFrame_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      fileExit_actionPerformed(null);
    }
  }


  /******************************************************************
   *  ATTENTION - This is the only important section in this FILE.
   */
  void Start_Bt_actionPerformed(ActionEvent e)
  {
    statusBar_ST.setText("Started search at:" + url_JT.getText());
    int depth = (new Integer(depth_JT.getText())).intValue();
    String url = url_JT.getText();
    String key = keyword_JT.getText();
    Vector keywords = new Vector();
    keywords.add(key);
    String dir = dir_JT.getText();
    DOMImageCrawler c = new DOMImageCrawler(depth,url,keywords,dir);
    c.addObserver(this);
    c.start();
  }

    public void notify(Observable o) 
    {
	DOMImageCrawler ic = (DOMImageCrawler) o;
	try
	{
	    Vector toVisit = new Vector();
	    Enumeration enum = ic.getToVisit().keys();
	    while(enum.hasMoreElements())
	    {
		URL elem = new URL((String)enum.nextElement());
		toVisit.add(new File(elem.getFile()).getName());
	    }
	
	    Vector visited = new Vector();
	    enum = ic.getVisited().keys();
	    while(enum.hasMoreElements())
	    {
		URL elem = new URL((String)enum.nextElement());
		visited.add(new File(elem.getFile()).getName());
	    }

	    leftToVisit_JL.setListData(toVisit);
	    alreadyVisited_JL.setListData(visited);
	    totalImages_JT.setText(new Integer(ic.getLoadedImagesCount()).toString());
	}
	catch(java.net.MalformedURLException e)
	{
	    System.err.println(e);
	}
    }
    
}







