//----------------------------------------------------------------------------
//~Author: Fabio Arciniegas A.
//~Name: Observable
//~Description: An implementation of the ObserverIF [GoF95] part of the 
//~ observer pattern in Java
//

//----------------------------------------------------------------------------
//             This code has been formated to fit in 80 columns
//----------------------------------------------------------------------------
package com.faa.patterns.Observer;

  /** 
      An implementation of the ObservableIF [GoF95] part of the 
      observer pattern in Java
   */
public interface Observer
{

/**
   receive notification of change from an observed object
   This is done in order to allow more than one observable object to be
   watched by the observer
   @param observable the observable object that just changed.
 */
    public void notify(Observable observable);
    
}

 
